package com.zhongzheng.modules.base.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.base.bo.ActivityAdvertisingAddBo;
import com.zhongzheng.modules.base.bo.ActivityAdvertisingEditBo;
import com.zhongzheng.modules.base.bo.ActivityAdvertisingQueryBo;
import com.zhongzheng.modules.base.domain.ActivityAdvertising;
import com.zhongzheng.modules.base.mapper.ActivityAdvertisingMapper;
import com.zhongzheng.modules.base.service.IActivityAdvertisingService;
import com.zhongzheng.modules.base.vo.ActivityAdvertisingVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 广告发布储存Service业务层处理
 *
 * @author hjl
 * @date 2022-01-13
 */
@Service
public class ActivityAdvertisingServiceImpl extends ServiceImpl<ActivityAdvertisingMapper, ActivityAdvertising> implements IActivityAdvertisingService {

    @Override
    public ActivityAdvertisingVo queryById(Long id){
        ActivityAdvertising db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, ActivityAdvertisingVo.class);
    }

    @Override
    public List<ActivityAdvertisingVo> queryList(ActivityAdvertisingQueryBo bo) {
        LambdaQueryWrapper<ActivityAdvertising> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getAdverUrl()), ActivityAdvertising::getAdverUrl, bo.getAdverUrl());
        lqw.eq(bo.getLocationId() != null, ActivityAdvertising::getLocationId, bo.getLocationId());
        lqw.eq(StrUtil.isNotBlank(bo.getJumpUrl()), ActivityAdvertising::getJumpUrl, bo.getJumpUrl());
        lqw.eq(StrUtil.isNotBlank(bo.getRemarks()), ActivityAdvertising::getRemarks, bo.getRemarks());
        lqw.in(bo.getStatus() != null, ActivityAdvertising::getStatus, bo.getStatus());
        lqw.eq(bo.getJumpType() != null, ActivityAdvertising::getJumpType, bo.getJumpType());
        lqw.orderByDesc(bo.getSort() != null, ActivityAdvertising::getSort);
        lqw.like(StrUtil.isNotBlank(bo.getAdvName()), ActivityAdvertising::getAdvName, bo.getAdvName());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ActivityAdvertisingVo> entity2Vo(Collection<ActivityAdvertising> collection) {
        List<ActivityAdvertisingVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ActivityAdvertisingVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ActivityAdvertising> page = (Page<ActivityAdvertising>)collection;
            Page<ActivityAdvertisingVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ActivityAdvertisingAddBo bo) {
        ActivityAdvertising add = BeanUtil.toBean(bo, ActivityAdvertising.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ActivityAdvertisingEditBo bo) {
        ActivityAdvertising update = BeanUtil.toBean(bo, ActivityAdvertising.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ActivityAdvertising entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
